KeyFactory (Java 2 Platform SE v1.4.1_"07")

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

JavaTM 2 Platform
Std. Ed. v1.4.1_"07"

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class KeyFactory

    java.lang.Object
      |
      +--java.security.KeyFactory

public class KeyFactory
extends Object

Key factories are used to convert keys (opaque cryptographic keys of type `Key`) into key specifications (transparent representations of the underlying key material), and vice versa.

Key factories are bi-directional. That is, they allow you to build an opaque key object from a given key specification (key material), or to retrieve the underlying key material of a key object in a suitable format.

Multiple compatible key specifications may exist for the same key. For example, a DSA public key may be specified using `DSAPublicKeySpec` or `X509EncodedKeySpec`. A key factory can be used to translate between compatible key specifications.

The following is an example of how to use a key factory in order to instantiate a DSA public key from its encoding. Assume Alice has received a digital signature from Bob. Bob also sent her his public key (in encoded format) to verify his signature. Alice then performs the following actions:

     X509EncodedKeySpec bobPubKeySpec = new X509EncodedKeySpec(bobEncodedPubKey);
     KeyFactory keyFactory = KeyFactory.getInstance("DSA");
     PublicKey bobPubKey = keyFactory.generatePublic(bobPubKeySpec);
     Signature sig = Signature.getInstance("DSA");
     sig.initVerify(bobPubKey);
     sig.update(data);
     sig.verify(signature);

Since:
  1.2
See Also:
  `Key`, `PublicKey`, `PrivateKey`, `KeySpec`, `DSAPublicKeySpec`, `X509EncodedKeySpec`

Constructor Summary
`protected` | `KeyFactory(KeyFactorySpi keyFacSpi, Provider provider, String algorithm)` Creates a KeyFactory object.

Method Summary
`PrivateKey` | `generatePrivate(KeySpec keySpec)` Generates a private key object from the provided key specification (key material).
`PublicKey` | `generatePublic(KeySpec keySpec)` Generates a public key object from the provided key specification (key material).
`String` | `getAlgorithm()` Gets the name of the algorithm associated with this `KeyFactory`.
`static KeyFactory` | `getInstance(String algorithm)` Generates a KeyFactory object that implements the specified algorithm.
`static KeyFactory` | `getInstance(String algorithm, Provider provider)` Generates a KeyFactory object for the specified algorithm from the specified provider.
`static KeyFactory` | `getInstance(String algorithm, String provider)` Generates a KeyFactory object for the specified algorithm from the specified provider.
`KeySpec` | `getKeySpec(Key key, Class keySpec)` Returns a specification (key material) of the given key object.
`Provider` | `getProvider()` Returns the provider of this key factory object.
`Key` | `translateKey(Key key)` Translates a key object, whose provider may be unknown or potentially untrusted, into a corresponding key object of this key factory.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyFactory

    protected KeyFactory(KeyFactorySpi keyFacSpi,
                         Provider provider,
                         String algorithm)

  Creates a KeyFactory object.

Parameters:
  `keyFacSpi` - the delegate
  `provider` - the provider
  `algorithm` - the name of the algorithm to associate with this `KeyFactory`

Method Detail

### getInstance

    public static KeyFactory getInstance(String algorithm)
                                  throws NoSuchAlgorithmException

  Generates a KeyFactory object that implements the specified algorithm. If the default provider package provides an implementation of the requested algorithm, an instance of KeyFactory containing that implementation is returned. If the algorithm is not available in the default package, other packages are searched.

  Parameters:
    `algorithm` - the name of the requested key algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
  Returns:
    a KeyFactory object for the specified algorithm.
  Throws:
    `NoSuchAlgorithmException` - if the requested algorithm is not available in the default provider package or any of the other provider packages that were searched.

### getInstance

    public static KeyFactory getInstance(String algorithm,
                                         String provider)
                                  throws NoSuchAlgorithmException,
                                         NoSuchProviderException

  Generates a KeyFactory object for the specified algorithm from the specified provider.

  Parameters:
    `algorithm` - the name of the requested key algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the name of the provider.
  Returns:
    a KeyFactory object for the specified algorithm.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available from the specified provider.
    `NoSuchProviderException` - if the provider has not been configured.
    `IllegalArgumentException` - if the provider name is null or empty.
  See Also:
    `Provider`

### getInstance

    public static KeyFactory getInstance(String algorithm,
                                         Provider provider)
                                  throws NoSuchAlgorithmException

  Generates a KeyFactory object for the specified algorithm from the specified provider. Note: the `provider` doesn't have to be registered.

  Parameters:
    `algorithm` - the name of the requested key algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the provider.
  Returns:
    a KeyFactory object for the specified algorithm.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available from the specified provider.
    `IllegalArgumentException` - if the `provider` is null.
  Since:
    1.4
  See Also:
    `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this key factory object.

  Returns:
    the provider of this key factory object

### getAlgorithm

    public final String getAlgorithm()

  Gets the name of the algorithm associated with this `KeyFactory`.

  Returns:
    the name of the algorithm associated with this `KeyFactory`

### generatePublic

    public final PublicKey generatePublic(KeySpec keySpec)
                                   throws InvalidKeySpecException

  Generates a public key object from the provided key specification (key material).

  Parameters:
    `keySpec` - the specification (key material) of the public key.
  Returns:
    the public key.
  Throws:
    `InvalidKeySpecException` - if the given key specification is inappropriate for this key factory to produce a public key.

### generatePrivate

    public final PrivateKey generatePrivate(KeySpec keySpec)
                                     throws InvalidKeySpecException

  Generates a private key object from the provided key specification (key material).

  Parameters:
    `keySpec` - the specification (key material) of the private key.
  Returns:
    the private key.
  Throws:
    `InvalidKeySpecException` - if the given key specification is inappropriate for this key factory to produce a private key.

### getKeySpec

    public final KeySpec getKeySpec(Key key,
                                    Class keySpec)
                             throws InvalidKeySpecException

  Returns a specification (key material) of the given key object. `keySpec` identifies the specification class in which the key material should be returned. It could, for example, be `DSAPublicKeySpec.class`, to indicate that the key material should be returned in an instance of the `DSAPublicKeySpec` class.

  Parameters:
    `key` - the key.
    `keySpec` - the specification class in which the key material should be returned.
  Returns:
    the underlying key specification (key material) in an instance of the requested specification class.
  Throws:
    `InvalidKeySpecException` - if the requested key specification is inappropriate for the given key, or the given key cannot be processed (e.g., the given key has an unrecognized algorithm or format).

### translateKey

    public final Key translateKey(Key key)
                           throws InvalidKeyException

  Translates a key object, whose provider may be unknown or potentially untrusted, into a corresponding key object of this key factory.

  Parameters:
    `key` - the key whose provider is unknown or untrusted.
  Returns:
    the translated key.
  Throws:
    `InvalidKeyException` - if the given key cannot be processed by this key factory.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

JavaTM 2 Platform
Std. Ed. v1.4.1_"07"

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2002 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms.